VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ScaleViewer"
   ClientHeight    =   5685
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5685
   ScaleWidth      =   5775
   Begin VB.PictureBox picHidden 
      Height          =   615
      Left            =   2400
      ScaleHeight     =   555
      ScaleWidth      =   555
      TabIndex        =   5
      Top             =   3720
      Width           =   615
   End
   Begin VB.PictureBox picImage 
      AutoSize        =   -1  'True
      Height          =   3495
      Left            =   2280
      ScaleHeight     =   3435
      ScaleWidth      =   3435
      TabIndex        =   4
      Top             =   0
      Width           =   3495
   End
   Begin VB.ComboBox PatternCombo 
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox DirList 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox FileList 
      Height          =   1845
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copy the image from pic_src into pic_dst so
' it fits and has the same aspect ratio as the
' original picture.
Private Sub FitPictureToBox(ByVal pic_src As PictureBox, pic_dst As PictureBox)
Dim aspect_src As Single
Dim wid As Single
Dim hgt As Single

    ' Get the original picture's aspect ratio.
    aspect_src = pic_src.ScaleWidth / pic_src.ScaleHeight

    ' Get the size available.
    wid = pic_dst.ScaleWidth
    hgt = pic_dst.ScaleHeight

    ' Adjust the wid/hgt ratio to match aspect_src.
    If wid / hgt > aspect_src Then
        ' The area is too short and wide.
        ' Make it narrower.
        wid = aspect_src * hgt
    Else
        ' The area is too tall and thin.
        ' Make it shorter.
        hgt = wid / aspect_src
    End If

    ' Center the image at the correct size.
    pic_dst.Cls
    pic_dst.PaintPicture pic_src.Picture, _
        (pic_dst.ScaleWidth - wid) / 2, _
        (pic_dst.ScaleHeight - hgt) / 2, _
        wid, hgt
End Sub
Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


Private Sub FileList_Click()
Dim fname As String

    On Error GoTo LoadPictureError

    fname = FileList.Path & "\" & FileList.FileName
    Caption = "Viewer [" & fname & "]"
    
    MousePointer = vbHourglass
    DoEvents

    ' Fit the picture into the PictureBox, centered.
    picHidden.Picture = LoadPicture(fname)
    FitPictureToBox picHidden, picImage
    MousePointer = vbDefault

    Exit Sub

LoadPictureError:
    Beep
    MousePointer = vbDefault
    Caption = "Viewer [Invalid picture]"
    Exit Sub
End Sub


Private Sub Form_Load()
    PatternCombo.AddItem "Bitmaps (*.bmp)"
    PatternCombo.AddItem "GIF (*.gif)"
    PatternCombo.AddItem "JPEG (*.jpg)"
    PatternCombo.AddItem "Icons (*.ico)"
    PatternCombo.AddItem "Matafiles (*.wmf)"
    PatternCombo.AddItem "DIBs (*.dib)"
    PatternCombo.AddItem "Graphic (*.gif;*.jpg;*.ico;*.bmp;*.wmf;*.dib)"
    PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = 0

    DriveList.Drive = App.Path
    DirList.Path = App.Path

    picHidden.AutoSize = True
    picHidden.Visible = False
End Sub

Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move GAP, GAP, wid
    PatternCombo.Move GAP, ScaleHeight - PatternCombo.Height, wid
    
    hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height - 3 * GAP) / 2
    If hgt < 100 Then hgt = 100
    DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt
    FileList.Move GAP, DirList.Top + DirList.Height + GAP, wid, hgt

    wid = ScaleWidth - picImage.Left
    If wid < 120 Then wid = 120
    picImage.Move picImage.Left, 0, wid, ScaleHeight
End Sub
Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.List(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub
